//============================================================================
// Name        : library.cpp
// Author      : r. takhanov
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <cstdlib>
#include "pattern.h"

using namespace std;

int main() {
	int num_words = 20;
	int num_chain = 100;
	int D = 2;
	Potential* myPotential = new Potential(num_chain, D, num_words+1);

	int i,j,k;

// adding patterns with cost
	for(i=0;i<num_words;i++)
	{
		// random word, e.g. of length 5
		wchar_t* p_str = new wchar_t[5];
		p_str[5] = L'\0';
		for(j=0;j<5;j++)
		{
			p_str[j] = (wchar_t) (rand()%D +1);
		}
		//random costs
		for(j=1;j<=num_chain-4;j++)
		{
			Cost c;
			c.i = j;
			c.j = j+4;
			c.alpha = p_str;
			c.cost = rand()/RAND_MAX;
			myPotential->add_pattern(&c);
		}
	}

	// first preprocess words
	myPotential->words_preprocess();
	// after preprocessing of words you can change weights of patterns without calling word_preproccess()

	// then preprocess weights
	myPotential->weights_preprocess();
	cout << "MAP:";
	wchar_t* res = myPotential->compute_map();
	for(i=0;i<num_chain;i++)
	{
		cout << res[i] << "\t";
	}
	cout << "\nSample:";
	wchar_t* sample = myPotential->sample();
	for(i=0;i<num_chain;i++)
	{
		cout << sample[i] << "\t";
	}
	cout << "\nLogZ = " << myPotential->compute_stat_sum() << "\n";

	return 0;
}
